<?php

namespace Moderation;

use Core\Db;
use DateTime;

// todo         .
// todo      .     !
// todo    .

class Moderation
{
    private const JAIL_ROOM = 274;
    private const CENTRAL_SQUARE_ROOM = 9;
    private const JAIL_STORAGE = 1357908642; /* , ! */

    private int $target;

    public function __construct(int $userid)
    {
        $this->target = $userid;
    }

    /**
     * 
     * @param DateTime    $expiration  .
     * @param string|null $reason      .
     */public function silence(DateTime $expiration, ?string $reason = null)
    {
        Db::sql('update users set molch1 = ? where id = ?', [$expiration->getTimestamp(), $this->target]);
    }

    /**
     *  
     */
    public function unsilence()
    {
        Db::sql('update users set molch1 = default where id = ?', [$this->target]);
    }

    /**
     * 
     * @param DateTime    $expiration  .
     * @param string|null $reason      .
     */
    public function depersonalize(DateTime $expiration, ?string $reason = null)
    {
        Db::sql('update users set info_delete = ? where id = ?', [$expiration->getTimestamp(), $this->target]);
    }

    /**
     *  
     */
    public function undepersonalize()
    {
        Db::sql('update users set info_delete = default where id = ?', [$this->target]);
    }

    /**
     * 
     * @param DateTime    $expiration  .
     * @param string|null $reason      .
     */
    public function prison(DateTime $expiration, ?string $reason = null)
    {
        Db::sql('update users set jail = ?, room = ? where id = ?', [
            $expiration->getTimestamp(),
            self::JAIL_ROOM,
            $this->target,
        ]);
        Db::sql('update items_users set `delete` = ? where `delete` = 0 and uid = ?', [
            self::JAIL_STORAGE,
            $this->target,
        ]);
    }

    /**
     *  
     */
    public function unprison()
    {
        Db::sql('update users set jail = default, room = ? where id = ?', [
            self::CENTRAL_SQUARE_ROOM,
            $this->target,
        ]);
        Db::sql('update items_users set `delete` = default where `delete` = ? and uid = ?', [
            1357908642,
            $this->target,
        ]);
    }

    /**
     * 
     * @param string|null $reason      .
     */
    public function ban(?string $reason = null)
    {
        Db::sql('update users set banned = unix_timestamp() where id = ?', [$this->target]);
    }

    /**
     *  
     */
    public function unban()
    {
        Db::sql('update users set banned = default where id = ?', [$this->target]);
    }

    /**
     *  
     * @param Target        $uid   .
     * @param DateTime|null $date  ,    -   .
     */
    public function showItemTransferLogs(Target $uid, ?DateTime $date)
    {
        // TODO: Implement showItemTransferLogs() method.
    }
}